﻿
namespace CCSPrototypeCommon
{

    using System;
    using System.Data.Entity;
    using System.Data.Entity.Infrastructure;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;

    public class RawDataContext : DbContext
    {
        public RawDataContext()
            : base("name=BillDbConnectionString")
        { }

        public RawDataContext(string connString)
            : base(connString)
        { }

        public virtual DbSet<CCS_RawData_V1> RawDataTable { get; set; }

        public virtual DbSet<CCS_PhoneData_V1> PhoneDataTable { get; set; }

        public virtual DbSet<CCS_MeterData_V1> MeterDataTable { get; set; }
        public virtual DbSet<CCS_MeterData_Sub_V1> MeterDataSubTable { get; set; }

        public virtual DbSet<CCS_PhoneMeterRef_V1> PhoneMeterRefTable { get; set; }

       
    }

}

