﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace CCSPrototypeCommon
{
    public class CCS_FailedActions_V1
    {

        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public Guid ID { get; set; }


        public ACTIONSTYPE ActionType { get; set; }

        public string Parameters { get; set; }

        public string Message { get; set; }

        [DisplayFormat(DataFormatString = "{0:yyyy年MM月dd日 HH时mm分}", ApplyFormatInEditMode = true)]
        public DateTime ModifiedDate { get; set; }
    }
}
