﻿namespace CCSPrototypeCommon
{

    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;


    public class CCS_MonthlyAmountDueSummary_V1
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public long Id { get; set; }

        public double AmountDue { get; set; }

        public double Balance { get; set; }

        [DataType(DataType.Date)]
        public DateTime BillPeriod { get; set; }


        public DateTime? ModifiedDate { get; set; }

        public Guid CustomerID { get; set; }

        [ForeignKey("CustomerID")]
        public virtual CCS_Customer_V1 CustomerTable { get; set; }
    }
}
