﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CCSPrototypeCommon
{
    public class CCS_SubscriptionPaymentInfo_V1
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public Guid PaymentInfoID { get; set; }

        public Guid PaymentID { get; set; }

        [ForeignKey("PaymentID")]
        public virtual CCS_SubscriptionPayment_V1 Payment { get; set; }

        [DisplayName("Payment TradeNo 缴费交易号")]
        public string PaymentOutTradeNo { get; set; }

        public string result { get; set; }
    }
}
