namespace CCSPrototypeCommon
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;

    public partial class Payment_Wechat_Statement_Comparison_Fail_Transaction_On_CCS_Only_V1
    {
        public string PaymentOutTradeNo { get; set; }

        [Key]
        [Column(Order = 0)]
        public Guid PaymentNotifID { get; set; }

        [Key]
        [Column(Order = 1)]
        public Guid PaymentInfoID { get; set; }

        public string PaymentTradeNo { get; set; }

        public string PaymentBuyerEmail { get; set; }

        public string PaymentSubject { get; set; }

        public double? PaymentDiscount { get; set; }

        public int? PaymentType { get; set; }

        public string PaymentNotifyType { get; set; }

        public int? PaymentQuantity { get; set; }

        public DateTime? PaymentCreateTime { get; set; }

        public string PaymentSellerID { get; set; }

        public DateTime? PaymentNotifyTime { get; set; }

        public string PaymentBody { get; set; }

        public string PaymentTradeStatus { get; set; }

        public string PaymentIsTotalFeeAdjust { get; set; }

        public double? PaymentTotalFee { get; set; }

        public DateTime? PaymentGMTPayment { get; set; }

        public string PaymentSellerEmail { get; set; }

        public double? PaymentPrice { get; set; }

        public string PaymentNotifyID { get; set; }

        public string PaymentUseCoupon { get; set; }

        public string PaymentSignType { get; set; }

        public string PaymentSign { get; set; }

        public string WeChatAppId { get; set; }

        public string WeChatBankType { get; set; }

        public double? WeChatCashFee { get; set; }

        public string WeChatFeeType { get; set; }

        public string WeChatIsSubscribe { get; set; }

        public string WeChatMchId { get; set; }

        public string WeChatNonce { get; set; }

        public string WeChatOpenId { get; set; }

        public string WeChatResultCode { get; set; }

        public string WeChatReturnCode { get; set; }

        public string WeChatSign { get; set; }

        public string WeChatTimeEnd { get; set; }

        public double? WeChatTotalFee { get; set; }

        public string WeChatTradeType { get; set; }

        public string WeChatTransactionId { get; set; }

        public long? row { get; set; }

        public Guid? StatementID { get; set; }

        public string TradeTime { get; set; }

        public string WxAppId { get; set; }

        public string MerchantId { get; set; }

        public string SubMerchantId { get; set; }

        public string DeviceId { get; set; }

        public string WxOrderId { get; set; }

        public string MerchantOrderId { get; set; }

        public string UserId { get; set; }

        public string TransactionType { get; set; }

        public string TransactionStatus { get; set; }

        public string PayerBank { get; set; }

        public string CurrencyType { get; set; }

        public double? TotalPaymentAmount { get; set; }

        public double? TotalCouponPaymentAmount { get; set; }

        public string ProductName { get; set; }

        public string ProductDescription { get; set; }

        public double? ProcessingFee { get; set; }

        public string ProcessingFeeRate { get; set; }

        public string WxRefundId { get; set; }

        public string MerchantRefundId { get; set; }

        public double? RefundAmount { get; set; }

        public double? RefundCouponAmount { get; set; }

        public string RefundType { get; set; }

        public string RefundStatus { get; set; }
    }
}
