﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel.DataAnnotations;
using PagedList;

namespace CCSPrototypeCommon.Query
{
    public class BaseFilter
    {
        public Guid BaseSearchID = Guid.NewGuid();
        public string SelectedBaseType = String.Empty;
        public List<string> ListBaseTypes = new List<string>();
        public List<string> ListColumns = new List<string>();
        public BaseFilter()
        {

        }

        //public PagedList.IPagedList<CCSPrototypeCommon.Bill> pagedList = null;
        [Required(ErrorMessage = "请选择查询条件")]
        public string SelectedCategory { get; set; }

        public AbstractFilter searchModel { get; set; }

    }
}