﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CCSPrototypeCommon
{
    /**
    * 	配置账号信息
    */
    public class WxPayConfig
    {
        //=======【基本信息设置】=====================================
        /* 微信公众号信息配置
        * APPID：绑定支付的APPID（必须配置）
        * MCHID：商户号（必须配置）
        * KEY：商户支付密钥，参考开户邮件设置（必须配置）
        * APPSECRET：公众帐号secert（仅JSAPI支付的时候需要配置）
        */

        public const string KEY_UserApp = "aaaaaaaaaabbbbbbbbbbccccccccccdd";
        public const string APPID_UserApp = "wx3df62cc8fadafb87";
        public const string MCHID_UserApp = "1268827001";

        public const string KEY_VendorApp = "916f1e2c751d4e63bedf02e7051c8b98";
        public const string APPID_VendorApp = "wx522fc8b15989f76b";
        public const string MCHID_VendorApp = "1285266001";

        //=======【证书路径设置】===================================== 
        /* 证书路径,注意应该填写绝对路径（仅退款、撤销订单时需要）
        */
        //public const string SSLCERT_PATH = "cert/apiclient_cert.p12";
        //public const string SSLCERT_PASSWORD = "1233410002";



       
        //=======【商户系统后台机器IP】===================================== 
        /* 此参数可手动配置也可在程序中自动获取
        */
        public const string IP = "8.8.8.8";


        //=======【上报信息配置】===================================
        /* 测速上报等级，0.关闭上报; 1.仅错误时上报; 2.全量上报
        */
        public const int REPORT_LEVENL = 1;

        //=======【日志级别】===================================
        /* 日志等级，0.不输出日志；1.只输出错误信息; 2.输出错误和正常信息; 3.输出错误信息、正常信息和调试信息
        */
        public const int LOG_LEVENL = 0;
    }
}