﻿using System.Web;
using System.Web.Optimization;

namespace HomeWeb
{
    public class BundleConfig
    {
        // For more information on Bundling, visit http://go.microsoft.com/fwlink/?LinkId=254725
        public static void RegisterBundles(BundleCollection bundles)
        {
            bundles.Add(new ScriptBundle("~/bundles/jquery").Include(
                        "~/Scripts/jquery-{version}.js"));

            bundles.Add(new ScriptBundle("~/bundles/jqueryval").Include(
                        "~/Scripts/jquery.unobtrusive*",
                        "~/Scripts/jquery.validate*"));

            bundles.Add(new ScriptBundle("~/bundles/bootstrap").Include(
             "~/Scripts/bootstrap.js",
             "~/Scripts/respond.js"));

            bundles.Add(new ScriptBundle("~/bundles/user").Include(
                        "~/Scripts/jquery-{version}.js",
                        "~/Scripts/bootstrap.min.js",
                        "~/Scripts/app.js"));

            bundles.Add(new ScriptBundle("~/bundles/merchant").Include(
                        "~/Scripts/app.js"));

            bundles.Add(new ScriptBundle("~/bundles/map").Include(
                        "~/Scripts/CCSMap.js"));

            bundles.Add(new StyleBundle("~/Content/user").Include(
                        "~/Content/custom.css"));

            bundles.Add(new ScriptBundle("~/bundles/metisMenu").Include(
                        "~/SBAdmin/bower_components/metisMenu/dist/metisMenu.js"));

            bundles.Add(new ScriptBundle("~/bundles/sbadmin").Include(
                        "~/SBAdmin/dist/js/sb-admin-2.js"));

            bundles.Add(new StyleBundle("~/Content/metisMenu").Include(
                        "~/SBAdmin/bower_components/metisMenu/dist/metisMenu.css"));
            bundles.Add(new StyleBundle("~/Content/timeline").Include(
                    "~/SBAdmin/dist/css/timeline.css"));
            bundles.Add(new StyleBundle("~/Content/sbadmin").Include(
                    "~/SBAdmin/dist/css/sb-admin-2.css"));
            bundles.Add(new StyleBundle("~/Content/fontawesome").Include(
                    "~/SBAdmin/bower_components/font-awesome/css/font-awesome.css"));

            bundles.Add(new StyleBundle("~/Content/bootstrap").Include(
                      "~/Content/bootstrap.css"));

            bundles.Add(new StyleBundle("~/Content/lightbox").Include(
                    "~/Content/lightbox.min.css"));

            bundles.Add(new ScriptBundle("~/bundles/lightbox").Include(
                    "~/Scripts/lightbox.min.js"));
            
            // Use the development version of Modernizr to develop with and learn from. Then, when you're
            // ready for production, use the build tool at http://modernizr.com to pick only the tests you need.
            bundles.Add(new ScriptBundle("~/bundles/modernizr").Include(
                        "~/Scripts/modernizr-*"));

            bundles.Add(new StyleBundle("~/bundles/CKEditorCSS").Include(
                "~/Scripts/ckeditor/contents.css"));

            bundles.Add(new ScriptBundle("~/bundles/CKEditorJS").Include(
                "~/Scripts/ckeditor/ckeditor.js"));

            bundles.Add(new ScriptBundle("~/bundles/amchartsJS").Include(
                "~/Scripts/amcharts/amcharts.js"));

            bundles.Add(new ScriptBundle("~/bundles/amchartsSerialJS").Include(
                "~/Scripts/amcharts/serial.js"));

            bundles.Add(new ScriptBundle("~/bundles/amchartsThemeDarkJS").Include(
                "~/Scripts/amcharts/themes/dark.js"));

            bundles.Add(new StyleBundle("~/Content/css").Include("~/Content/site.css"));

            bundles.Add(new StyleBundle("~/Content/custom-merchant").Include("~/Content/custom-merchant.css"));
            
        }
    }
}