﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace HomeWeb
{
    public class RouteConfig
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            // End user entry
            routes.MapRoute(
                name: "User",
                url: "User/{action}/{id}",
                defaults: new { controller = "User", action = "Index", id = UrlParameter.Optional }
                );


            // Merchant entry
            routes.MapRoute(
                name: "Merchant",
                url: "Merchant/{action}/{id}",
                defaults: new { controller = "Merchant", action = "Login", id = UrlParameter.Optional }
                );

             // RawData entry
             routes.MapRoute(
                name: "RawData",
                url: "RawData/{action}/{id}",
                defaults: new { controller = "RawData", action = "Index", id = UrlParameter.Optional }
                );

            routes.MapRoute(
                name: "Default",
                url: "{controller}/{action}/{id}",
                defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional }
            );
        }
    }
}