﻿
namespace HomeWeb.Models
{

    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;

    public class ColumnMappingTemplateModel
    {
        public ColumnMappingTemplateModel() 
        {
            CsvHeaderList = new List<string>();
            TemplateColumnList = new List<string>();
            ExistMapping = new Dictionary<string, string>();
            TemplateColumnTranslating = new Dictionary<string, string>();
        }

        public List<string> CsvHeaderList { get; set; }

        public List<string> TemplateColumnList { get; set; }

        public Dictionary<string, string> ExistMapping { get; set; }

        public Dictionary<string, string> TemplateColumnTranslating { get; set; }

        [Required]
        [MinLength(3)]
        [DisplayName("上传模板类型")]
        public string TemplateType { get; set; }
    }
}