﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;

namespace HomeWeb.Models
{
    public class LogInModel
    {
        [StringLength(128, MinimumLength = 5)]
        [Display(Name = "User Name 登陆账号")]
        public string UserName { get; set; }

        [Display(Name = "手机验证码")]
        public string VerificationCode { get; set; }

        [Display(Name = "手机号码")]
        public string Mobile { get; set; }

        [Display(Name = "下次自动登录 (请不要在公共设备上开启此功能)")]
        public bool SaveCookie { get; set; }

         [Display(Name = "错误信息")]
        public string ErrorMsg { get; set; }

    }
}