
function isNativeApp() {
    return /ccschinaportalmobile\/[0-9\.]+$/.test(navigator.userAgent);
}
function isNativeAppIOS() {
    return /ccschinaportaliosmobile\/[0-9\.]+$/.test(navigator.userAgent);
}


function SetButtonStatus(obj, ButtonID)
{
    if ($(obj) == null )
    {
        return;
    }

    if ($(obj).val() == '')
    {
        DisableButton(ButtonID)
    }
    else
    {
        EnableButton(ButtonID)
    }

}

function DisableButton(ButtonID) {

    var target = $('#' + ButtonID);
    if (target == null) {
        return;
    }

    if (false == target.hasClass('disabled')) {
        target.toggleClass('disabled');
    }

    target.attr("disabled", "disabled");
}

function EnableButton(ButtonID)
{

    var target = $('#' + ButtonID);
    if (target == null)
    {
        return;
    }

    if (target.hasClass('disabled'))
    {
        target.removeClass('disabled');
    }

    target.removeAttr("disabled");
}

function OnQueryButtonSubmit(displayTargetId) {
    return OnRegularButtonSubmit(displayTargetId);
}

function OnRegularButtonSubmit(displayTargetId) {

    if (displayTargetId != null) {
        var obj = $("#" + displayTargetId);
        if (obj != null) {
            obj.html("<br/><h4 class=\"text-center\">正在执行您的请求，请稍候。</h4>");
        }
    }
}

function ShowWaitingDialog() {
    if (isNativeApp() || isNativeAppIOS()) {
        return;
    }
    $("#DivOfLoadingSpin").modal();
}
function HideWaitingDialog() {
    $("#DivOfLoadingSpin").modal('hide');
}

$(document).ready(function () {

    if (isNativeApp() || isNativeAppIOS()) {
        return;
    }
    $("form").bind('submit', ShowWaitingDialog);
    $("form").bind("invalid-form.validate", InValidation);
    $("#main-sidebar a[href!=''][href!='#']").bind("click", ShowWaitingDialog);

});

function InValidation(form, validator) {
    HideWaitingDialog();
}
