﻿
namespace HomeWeb.Utils
{
    using CCSPrototypeCommon;

    internal static class GraphConfiguration
    {
        private const string tenantIdClaimType = "http://schemas.microsoft.com/identity/claims/tenantid";
        private static string graphResourceId = ConfigurationMgr.GetSetting("ida:GraphUrl");
        private static string graphApiVersion = ConfigurationMgr.GetSetting("ida:GraphApiVersion");

        internal static string GraphApiVersion
        {
            get { return graphApiVersion; }
            set { graphApiVersion = value; }
        }

        internal static string GraphResourceId
        {
            get { return graphResourceId; }
            set { graphResourceId = value; }
        }

        internal static string TenantIdClaimType
        {
            get { return tenantIdClaimType; }
        }
    }
}