package my.ccs.projectrawdata;

import android.net.wifi.WifiConfiguration;

import java.util.Dictionary;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by Hayk on 12/6/2015.
 */


public class Constants {

    public class ServerURLs
    {
        public static final String getCustomersUrl = "http://cloudcomspace.cloudapp.net/Rawdata/GetCustomerIdsForDeviceId";
        public static final String uploadDataUrl = "http://cloudcomspace.cloudapp.net/Merchant/UploadMeterData";
        public static final String verifyAccessWithCustomerIdUrl = "http://cloudcomspace.cloudapp.net/Rawdata/VerifyAccessCodeWithCustomerId";
        public static final String uploadMeterDataUrl = "http://cloudcomspace.cloudapp.net/RawData/UploadMeterInfoMobile";
        public static final String getMeterProfilesUrl = "http://cloudcomspace.cloudapp.net/rawdata/GetMeterProfiles";
        public static final String uploadRawDataUrl = "http://cloudcomspace.cloudapp.net/merchant/UploadRawDataMobile";
        public static final String whatIsNewUrl = "http://cloudcomspace.cloudapp.net/rawdata/ShowWhatIsNew";
    }

    public static final String userAgentString = "ccschinaportalmobile/1.0";
    public static String JSONRespAndroidRawDataBuildVersionTag = "androidRawDataBuildVersion";
    public static final String MyTag = "MyTag";
    public static final String EMPTYSTRING = "";


    public static String JSONReqAccessCodeTag = "AccessCode";
    public static String JSONReqDeviceIDTag = "DeviceId";
    public static String JSONReqCustomerIdTag = "CustomerId";

    public static String JSONRespStatusCodeTag = "statusCode";
    public static String JSONRespStatusMsgTag = "statusMsg";

    public class Json_Meter_Tags
    {

        public static final String JSONRespMeterDataTag= "meterData";
        public static final String JSONRespMeterDataIDTag= "MeterDataID";
        public static final String JSONRespMeterIDListTag= "MeterIDList";
        public static final String JSONRespMeterLocationCodeTag= "MeterLocationCode";
        public static final String JSONRespMeterIDTag= "MeterID";
        public static final String JSONRespMeterLatitudeTag= "Latitude";
        public static final String JSONRespMeterLongitudeTag= "Longitude";
        public static final String JSONRespPhoneUUIDTag= "PhoneUUID";
        public static final String JSONRespMeterSNTag= "MeterSN";
        public static final String JSONRespUserNameTag= "UserName";
        public static final String JSONRespMeterTypeTag= "MeterType";
        public static final String JSONRespMeterAddressTag = "Address";
        public static final String JSONRespCustomerIdTag = "CustomerId";
        public static final String JSONRespLocationCodeTag = "LocationCode";
    }

    public static String JSONRespImagesTag = "Images";
    public static String JSONRespCustomerIdsTag = "customerIds";

    class Json_Customer_Tags {
        public static final String JSONRespCustomerIDTag = "CustomerID";
        public static final String JSONRespCustomerNameTag = "Name";
    }

    public static String ChosenMeterTypeKey =  "ChosenMeterType";
    public static String MeterDataIDKey = "MeterDataID";
    public static String MeterSNKey = "MeterSN";
    public static String MeterAddressKey = "MeterAddress";
    public static String MeterBuildingNumKey = "MeterBuildingNum";
    public static String MeterCustomerIDKey = "MeterCustomerID";
    public static String MeterCustomerNameKey = "MeterCustomerName";

    public static long ACCESSCODE_EXPIRATION_PERIOD = 60 * 60000; //in milliseconds


    // File upload url (replace the ip with your server address)

    // Directory name to store captured images and videos
    public static final String IMAGE_DIRECTORY_NAME = "Android File Upload";

    public static final String DEVICEIDCHINESE = "手机设备编号";
    public static final String DIALOGTITLE = "点通网抄表";
    public static final String RETRIEVECUSTOMERSMSG = "正在检验用户身份……";
    public static final String ACCESSVERIFYMSG = "正在检验用户身份……";
    public static final String DOWNLOADINGMSG = "正在下载用户档案……";

    public static final String UPLOADINGMSG = "正在上传抄表数据……";
    public static final String UPLOADSUCCESS = "上传抄表数据成功！";
    public static final String UPLOADFAIL = "上传抄表数据失败！";

    public static String[] DevicesWithFakeLocation = {"A45E7DFCDFF54DC9", "DF73626A53E26350",
            "C51BD35AE48815C3", "CC357FBF4895FD6E", "E825B36DA41A44AE", "435081A0D05E9D8B"};

    public static final String DEVICEIDCANNOTBEEMPTY = "设备编号不能为空！";
    public static final String ACCESSCODECANNOTBEEMPTY = "访问密码不能为空！";

    public static final String DEVICEIDCOPIEDSUCCESS = "设备编号已拷贝至剪贴板！";
    public static final String DEVICEIDCOPIEDFAILURE = "拷贝设备编号失败！";

    public static final String OperationCancelled = "操作已被取消";
    public static final String CameraNotSupported = "此设备不支持照相功能";
    public static final String RequiredDataMissing = "请输入数据";

    public static final String WiFi = "WiFi";
    public static final String Bus = "Bus";
    public static final String Electronic = "Electronic";
    public static final String Manual = "Manual";

    public class StatusCodes
    {
        public static final String SUCCESS = "200";
    }
    public class StatusMessages
    {
        public static final String JSONTAGNOTBEFOUNDMSG = "JSON标识符丢失";
        public static final String JSONFORMATINCORRECTMSG = "分析JSON数据失败";
        public static final String REQUESTSUCCESSMSG = "操作成功";
        public static final String REQUESTFAILEDGENERICMSG = "发生未知错误";
        public static final String REQUESTFAILEDNORESPONSEMSG = "服务器未响应";
        public static final String REQUESTFAILEDWITHSTATUSCODEMSG = "操作失败，错误码：";
        public static final String TOBEIMPLEMENTED = "此功能待开发";
        public static final String CANNOTPROCEEDWITHACTION = "该操作失败，对象未定义或为空";
        public static final String COLUMNLISTEMPTY = "Column list is empty";
        public static final String DOWNLOADMETERFAILUREMSG = "下载用户档案失败！";
        public static final String DOWNLOADMETERSUCCESSMSG = "下载用户档案成功！";
        public static final String DOWNLOADMETERDEVICEDISABLEDMSG = "设备已被禁用。";
        public static final String DOWNLOADMETERINCORRECTACCESSCODEMSG = "访问密码错误。";
        public static final String DOWNLOADMETERDEVICEIDISNULLOREMPTYMSG = "设备编号不能为空。";
        public static final String DOWNLOADMETERACCESSCODEISNULLOREMPTYMSG = "服务密码不能为空。";
        public static final String DOWNLOADMETERDEVICEIDNOTWHITELISTEDMSG = "该设备未注册。";
        public static final String DOWNLOADMETERCONSISTENCYERRORMSG = " 该设备被重复注册。";
        public static final String DOWNLOADMETERFAILURENONJSONDATAMSG = "服务器端返回的数据格式错误。";
    }


    public static String SAVESETTINGSUCCESSFULLY = "设置保存成功!";
    public static final String ALERTDIALOGTITLE = "数据采集完毕.";
    public static final String COPIEDDEVICEID = "设备ID已拷贝";


    static class DataUploadStatus
    {
        public enum STATUS{
            NO_DATA,
            DB_DOESNOTEXIST,
            OUT_OF_MEMORY,
            FAILED_WITH_RESPONSECODE,
            UNKNOWN_ERROR,
            SUCCESS
        }
        STATUS status;
        public String appendMsg = "";
        private static final Map<STATUS, String> statusCodeToMsg;
        static
        {
            statusCodeToMsg = new HashMap<STATUS, String>();
            statusCodeToMsg.put(STATUS.NO_DATA, "数据不存在");
            statusCodeToMsg.put(STATUS.DB_DOESNOTEXIST, "数据库不存在");
            statusCodeToMsg.put(STATUS.UNKNOWN_ERROR, "发生未知错误");
            statusCodeToMsg.put(STATUS.SUCCESS, "上传顺利完成");
            statusCodeToMsg.put(STATUS.OUT_OF_MEMORY, "内存不足");
            statusCodeToMsg.put(STATUS.FAILED_WITH_RESPONSECODE, "操作失败，响应代码是：");
        }

        public String convertCodeToMsg()
        {
            if (statusCodeToMsg.containsKey(status)) {
                return statusCodeToMsg.get(status) + " " + appendMsg;
            }
            return statusCodeToMsg.get(STATUS.UNKNOWN_ERROR);
        }

        public  DataUploadStatus(STATUS status)
        {
            this.status = status;
        }

        public  DataUploadStatus(STATUS status, String appendMsg)
        {
            this(status);
            this.appendMsg = appendMsg;
        }
    }

    class BLE_TAGS
    {
        //{"冻结水量":4294967295,"反脉冲数":16,"剩余水量":"0吨","状态":0,"倍率":3,"正脉冲数":96,"rtcode":"0","冻结时间":"10天"}
        //{"Frozen water": 4294967295. "anti pulses": 16, "the remaining water": "0 t", "Status": 0, "override": 3, "positive pulses": 96, "rtcode": "0", "freeze time": "10 days"}
        public static final String BLERTCODETAG = "rtcode";
        public static final int BLERTCODESUCCESSTAG = 0;
        public static final int BLERTCODEFAILTAG = 1;
        public static final String BLEDESCTAG = "desc";
        public static final String BLEFROZENWATERTAG = "冻结水量";
        public static final String BLEANTIPULSESTAG = "反脉冲数";
        public static final String BLEREMAININGWATERTAG = "剩余水量";
        public static final String BLESTATUSTAG = "状态";
        public static final String BLEOVERRIDETAG = "倍率";
        public static final String BLEPOSITIVEPULSESTAG = "正脉冲数";
        public static final String BLEFREEZETIMETAG = "冻结时间";
        public static final String BLEUIDTAG = "表号";

    }

    public static int BLECONNECTTIMEOUT = 20;
    public static int BLEGETSINGLEDATATIMEOUT = 60;
    public static int BLEGETMULTIPLEDATATIMEOUT = 60;

    public static String TestDeviceID = "B91937A334ED28ED";






}
