package my.ccs.project.utils.basic;

import android.app.Activity;
import android.content.pm.ApplicationInfo;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.TimeZone;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

public class CCSUtilities {

    /*
    public static class LatLngModel
    {
        public Double lat;
        public Double lng;
        public LatLngModel(Double lat, Double lng)
        {
            this.lat = lat;
            this.lng = lng;
        }
    }
    public static boolean outOfChina(double lat, double lng)
    {
        return ! (72.004 <= lng && lng <= 137.8347 && 0.8293 <= lat && lat <= 55.8271);
    }

    public static double transformLat(double x, double y)
    {
        double ret = -100.0 + 2.0 * x + 3.0 * y + 0.2 * y * y + 0.1 * x * y + 0.2 * Math.sqrt(Math.abs(x));
        ret += (20.0 * Math.sin(6.0 * x * Math.PI) + 20.0 *
                Math.sin(2.0 * x * Math.PI)) * 2.0 / 3.0;
        ret += (20.0 * Math.sin(y * Math.PI) + 40.0 *
                Math.sin(y / 3.0 * Math.PI)) * 2.0 / 3.0;
        ret += (160.0 * Math.sin(y / 12.0 * Math.PI) + 320 *
                Math.sin(y * Math.PI / 30.0)) * 2.0 / 3.0;
        return ret;
    }



    public static double transformLon(double x, double y)
    {
        double ret = 300.0 + x + 2.0 * y + 0.1 * x * x +
                0.1 * x * y + 0.1 * Math.sqrt(Math.abs(x));
        ret += (20.0 * Math.sin(6.0 * x * Math.PI) + 20.0 *
                Math.sin(2.0 * x * Math.PI)) * 2.0 / 3.0;
        ret += (20.0 * Math.sin(x * Math.PI) + 40.0 *
                Math.sin(x / 3.0 * Math.PI)) * 2.0 / 3.0;
        ret += (150.0 * Math.sin(x / 12.0 * Math.PI) + 300.0 *
                Math.sin(x / 30.0 * Math.PI)) * 2.0 / 3.0;
        return ret;
    }

    public static LatLngModel delta(double lat, double lng)
    {
        double a = 6378245.0;
        double  ee = 0.00669342162296594323;
        double dLat = transformLat(lng - 105.0, lat - 35.0);
        double dLng = transformLon(lng - 105.0, lat - 35.0);
        double radLat = lat / 180.0 * Math.PI;
        double magic = Math.sin(radLat);
        magic = 1 - ee * magic * magic;
        double sqrtMagic = Math.sqrt(magic);
        dLat = (dLat * 180.0) / ((a * (1 - ee)) / (magic * sqrtMagic) * Math.PI);
        dLng = (dLng * 180.0) / (a / sqrtMagic * Math.cos(radLat) * Math.PI);
        return new LatLngModel(dLat, dLng);

    }


    public static LatLngModel gcj2wgs(double gcjLat, double gcjLng)
    {
        if(outOfChina(gcjLat, gcjLng))
            return new LatLngModel(gcjLat,gcjLng);
        LatLngModel temp = delta(gcjLat, gcjLng);
        return new LatLngModel(gcjLat - temp.lat,gcjLng - temp.lng);

    }

    public static LatLngModel bd2wgs(double bdLat, double bdLng){
        LatLngModel latLngModel = bd2gcj(bdLat, bdLng);
        return gcj2wgs(latLngModel.lat, latLngModel.lng);
    }

    public static LatLngModel bd2gcj(Double bdLat, Double bdLng)
    {
        if(bdLat == null || bdLat == null)
            return new LatLngModel(bdLat, bdLng);
        //if(outOfChina(bdLat, bdLng))
        //    return new LatLngModel(bdLat,bdLng);

        double x = bdLng - 0.0065;
        double y = bdLat - 0.006;
        double z = Math.hypot(x, y) - 0.00002 * Math.sin(y * Math.PI);
        double theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * Math.PI);
        double gcjLng = z * Math.cos(theta);
        double gcjLat = z * Math.sin(theta);
        return new LatLngModel(gcjLat, gcjLng);

    }*/

    public static String versionName;
}
