package my.ccs.project.utils.wechat;

import android.app.Activity;

import com.tencent.mm.sdk.openapi.IWXAPI;
import com.tencent.mm.sdk.openapi.WXAPIFactory;

import my.ccs.project.constants.CCSWeChatConstants;

/**
 * Created by Hayk on 6/20/2016.
 */
public class CCSWeChatManager {
    final public IWXAPI msgApi;
    final private Activity activity;
    public CCSWeChatManager(Activity activity)
    {
        this.activity = activity;
        msgApi = WXAPIFactory.createWXAPI(this.activity, CCSWeChatConstants.APP_ID, true);
        registerApp();

    }

    public void registerApp()
    {
        if(msgApi != null) msgApi.registerApp(CCSWeChatConstants.APP_ID);
    }

}
