//
//  CCSActivityIndicatorManager.swift
//  CCSChinaPortalUsers
//
//  Created by CCS China Portal on 6/17/16.
//  Copyright © 2016 CCS China Portal. All rights reserved.
//

import Foundation

class CCSActivityIndicatorManager {
    
    func startActivityIndicator(actInd: UIActivityIndicatorView!, loadingView: UIView!)
    {
        if(!actInd.isAnimating()){
            actInd.startAnimating();
            loadingView.hidden = false
        }
    }
    
    func stopActivityIndicator(actInd: UIActivityIndicatorView!, loadingView: UIView!)
    {
        if(actInd.isAnimating()){
            actInd.stopAnimating()
            loadingView.hidden = true
        }
    }
}
