//
//  EasyJSWebView.h
//  EasyJS
//
//  Created by Lau Alex on 19/1/13.
//  Copyright (c) 2013 Dukeland. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "EasyJSWebViewProxyDelegate.h"
@class TestClass;
@class CCSViewController;
@interface EasyJSWebView : UIWebView

// All the events will pass through this proxy delegate first
@property (nonatomic, retain) EasyJSWebViewProxyDelegate* proxyDelegate;

- (void) initEasyJS;
- (void) addJavascriptInterfaces:(NSObject*) interface WithName:(NSString*) name;

@end


@interface MyJSInterface : NSObject

@property (nonatomic, retain) CCSViewController* ccsViewController;
//@property (nonatomic, retain) TestClass* testClass;
-(id) initWithViewController:(UIViewController* )viewController;
-(void) performClick:(NSString*) paymentId amount:(NSString*) amount outTradeNo:(NSString*) outTradeNo methodID:(NSString*) methodID;
- (void)alert:(NSString *)title msg:(NSString *)msg;
-(void) setVendorLocation;

@end

