package com.alipay.sign;

import java.io.UnsupportedEncodingException;
import java.security.SignatureException;
import org.apache.commons.codec.digest.DigestUtils;

/** 
* ܣ֧MD5ǩļҪ޸
* 汾3.3
* ޸ڣ2012-08-17
* ˵
* ´ֻΪ˷̻Զṩ룬̻ԸԼվҪռĵд,һҪʹøô롣
* ôѧϰо֧ӿʹãֻṩһ
* */

public class MD5 {

    /**
     * ǩַ
     * @param text Ҫǩַ
     * @param key Կ
     * @param input_charset ʽ
     * @return ǩ
     */
    public static String sign(String text, String key, String input_charset) {
    	text = text + key;
        return DigestUtils.md5Hex(getContentBytes(text, input_charset));
    }
    
    /**
     * ǩַ
     * @param text Ҫǩַ
     * @param sign ǩ
     * @param key Կ
     * @param input_charset ʽ
     * @return ǩ
     */
    public static boolean verify(String text, String sign, String key, String input_charset) {
    	text = text + key;
    	String mysign = DigestUtils.md5Hex(getContentBytes(text, input_charset));
    	if(mysign.equals(sign)) {
    		return true;
    	}
    	else {
    		return false;
    	}
    }

    /**
     * @param content
     * @param charset
     * @return
     * @throws SignatureException
     * @throws UnsupportedEncodingException 
     */
    private static byte[] getContentBytes(String content, String charset) {
        if (charset == null || "".equals(charset)) {
            return content.getBytes();
        }
        try {
            return content.getBytes(charset);
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException("MD5ǩгִ,ָı뼯,Ŀǰָı뼯:" + charset);
        }
    }

}