package com.alipay.util;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Map;

import com.alipay.config.AlipayConfig;
import com.alipay.sign.MD5;

/* *
 *AlipayNotify
 *ܣ֧֪ͨ
 *ϸ֧ӿ֪ͨ
 *汾3.3
 *ڣ2012-08-17
 *˵
 *´ֻΪ˷̻Զṩ룬̻ԸԼվҪռĵд,һҪʹøô롣
 *ôѧϰо֧ӿʹãֻṩһο

 *************************ע*************************
 *֪ͨʱɲ鿴дlog־дTXTݣ֪ͨǷ
 */
public class AlipayNotify {

    /**
     * ֧Ϣַ֤
     */
    private static final String HTTPS_VERIFY_URL = "https://mapi.alipay.com/gateway.do?service=notify_verify&";

    /**
     * ֤ϢǷ֧ĺϷϢ
     * @param params ֪ͨĲ
     * @return ֤
     */
    public static boolean verify(Map<String, String> params) {

        //жresponsetTxtǷΪtrueisSignǷΪtrue
        //responsetTxtĽtrue⡢IDnotify_idһʧЧй
        //isSigntrue밲ȫУ롢ʱĲʽ磺Զȣʽй
    	String responseTxt = "true";
		if(params.get("notify_id") != null) {
			String notify_id = params.get("notify_id");
			responseTxt = verifyResponse(notify_id);
		}
	    String sign = "";
	    if(params.get("sign") != null) {sign = params.get("sign");}
	    boolean isSign = getSignVeryfy(params, sign);

        //д־¼Ҫԣȡעͣ
        //String sWord = "responseTxt=" + responseTxt + "\n isSign=" + isSign + "\n ػĲ" + AlipayCore.createLinkString(params);
	    //AlipayCore.logResult(sWord);

        if (isSign && responseTxt.equals("true")) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * ݷϢǩ
     * @param Params ֪ͨĲ
     * @param sign ȶԵǩ
     * @return ɵǩ
     */
	private static boolean getSignVeryfy(Map<String, String> Params, String sign) {
    	//˿ֵsignsign_type
    	Map<String, String> sParaNew = AlipayCore.paraFilter(Params);
        //ȡǩַ
        String preSignStr = AlipayCore.createLinkString(sParaNew);
        //ǩ֤
        boolean isSign = false;
        if(AlipayConfig.sign_type.equals("MD5") ) {
        	isSign = MD5.verify(preSignStr, sign, AlipayConfig.key, AlipayConfig.input_charset);
        }
        return isSign;
    }

    /**
    * ȡԶ̷ATN,֤URL
    * @param notify_id ֪ͨУID
    * @return ATN
    * ֤
    * invalid ⷵشpartnerkeyǷΪ 
    * true ȷϢ
    * false ǽǷֹ˿Լ֤ʱǷ񳬹һ
    */
    private static String verifyResponse(String notify_id) {
        //ȡԶ̷ATN֤Ƿ֧

        String partner = AlipayConfig.partner;
        String veryfy_url = HTTPS_VERIFY_URL + "partner=" + partner + "&notify_id=" + notify_id;

        return checkUrl(veryfy_url);
    }

    /**
    * ȡԶ̷ATN
    * @param urlvalue ָURL·ַ
    * @return ATN
    * ֤
    * invalid ⷵشpartnerkeyǷΪ 
    * true ȷϢ
    * false ǽǷֹ˿Լ֤ʱǷ񳬹һ
    */
    private static String checkUrl(String urlvalue) {
        String inputLine = "";

        try {
            URL url = new URL(urlvalue);
            HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
            BufferedReader in = new BufferedReader(new InputStreamReader(urlConnection
                .getInputStream()));
            inputLine = in.readLine().toString();
        } catch (Exception e) {
            e.printStackTrace();
            inputLine = "";
        }

        return inputLine;
    }
}
