﻿using System;
using CCSPayments.Model;

namespace CCSPayments
{
    public interface IPayment
    {
        /// <summary>
        /// Download the payment records with specified bill type on a particular day
        /// </summary>
        /// <param name="billDate">format: YYYYMMDD</param>
        /// <param name="type"></param>
        /// <returns>the payment records on the specified day</returns>
        IPaymentData DownloadBill(DateTime billDate, BillType type, WxConfiguration config);

    }
}
