﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CCSPrototypeCommon
{
    using System;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity;
    using System.Data.Entity.Infrastructure;

    public class LogsContext : DbContext
    {
        public LogsContext()
            : base("name=LogsDbConnectionString")
        { }

        public LogsContext(string connString)
            : base(connString)
        { }

        public virtual DbSet<CCS_Logs_V1> LogsTable { get; set; }
        public virtual DbSet<CCS_Meta_V1> MetaTable { get; set; }

    }

}
