﻿
namespace CCSPrototypeCommon
{

    using System;
    using System.Data.Entity;
    using System.Data.Entity.Infrastructure;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Linq;
    using System.Data.Entity.ModelConfiguration;


    public class PaymentContext : DbContext
    {
        public PaymentContext()
            : base("name=BillDbConnectionString")
        { 
        
        }

        public PaymentContext(string connString)
            : base(connString)
        { 
        
        }

        public virtual DbSet<CCS_Payment_V1> PaymentTable { get; set; }

        public virtual DbSet<CCS_PaymentInfo_V1> PaymentInfoTable { get; set; }

        public virtual DbSet<CCS_SubscriptionPayment_V1> SubscriptionPaymentTable { get; set; }

        public virtual DbSet<CCS_SubscriptionPaymentInfo_V1> SubscriptionPaymentInfoTable { get; set; }

        public virtual DbSet<CCS_Bill_V1> BillTable { get; set; }

        public virtual DbSet<CCS_Payment_AliPayNotif_V1> PaymentAliPayNotif { get; set; }

        public virtual DbSet<CCS_Payment_Statement_Wechat_V1> PaymentStatementWechatTable { get; set; }
        public virtual DbSet<CCS_Payment_Statement_Alipay_V1> PaymentStatementAlipayTable { get; set; }
        public virtual DbSet<Payment_Wechat_Statement_Comparison_Fail_Transaction_Match_Amount_Not_Match_V1> Payment_Wechat_Statement_Comparison_Fail_Transaction_Match_Amount_Not_Match_V1 { get; set; }
        public virtual DbSet<Payment_Wechat_Statement_Comparison_Fail_Transaction_On_CCS_Only_V1> Payment_Wechat_Statement_Comparison_Fail_Transaction_On_CCS_Only_V1 { get; set; }
        public virtual DbSet<Payment_Wechat_Statement_Comparison_Fail_Transaction_On_Wechat_Only_V1> Payment_Wechat_Statement_Comparison_Fail_Transaction_On_Wechat_Only_V1 { get; set; }
        public virtual DbSet<Payment_Wechat_Statement_Comparison_SUCCESS_V1> Payment_Wechat_Statement_Comparison_SUCCESS_V1 { get; set; }

        public virtual DbSet<CCS_UploadedPayment_V1> UploadedPaymentTable { get; set; }
    }
}
