﻿using System;
using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;

namespace CCSPrototypeCommon
{
    public class ViewsContext : DbContext
    {
         public ViewsContext()
            : base("name=BillDbConnectionString")
        { }

         public ViewsContext(string connString)
             : base(connString)
        { }

         public virtual DbSet<vwCCS_Daily_Total_Balance_V1> vwDailyTotalBalance { get; set; }

         public virtual DbSet<CCS_Daily_Payment_V1> dailyPaymentPerRole { get; set; }
         public virtual DbSet<vwCCS_Total_Balance_With_UserInfo_V1> vwTotalBalanceWithUserInfo { get; set; }

         public virtual DbSet<vwCCS_Blacklist_Bill_V1> vwBlacklistBill { get; set; }

        
    }
}
