﻿
namespace CCSPrototypeCommon
{
    using System;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;

    public class CCS_User_V1
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public Guid UserID { get; set; }

        [DisplayName("名(不包含姓氏)")]
        public string FirstName { get; set; }

        [DisplayName("姓氏")]
        public string LastName { get; set; }

        [DisplayName("手机号")]
        public string Cellphone { get; set; }

        [DisplayName("额外电话号码")]
        public string SecondPhone { get; set; }

        [DisplayName("电子邮件地址")]
        public string Email { get; set; }

        [DisplayName("地址")]
        public string Address { get; set; }

        [DisplayName("身份证号")]
        public string IDNumber { get; set; }

        [DisplayName("iOS设备令牌")]
        public string iOSDeviceToken { get; set; }

        public DateTime ModifiedDate { get; set; }
    }
}
