﻿namespace CCSPrototypeCommon
{

    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.ModelConfiguration;

    public class vwCCS_Total_Balance_With_UserInfo_V1
    {

        public class GroupPerCellPhone
        {
            [DisplayName("日期")]
            [DisplayFormat(DataFormatString = "{0:MM/dd/yyyy}")]
            public DateTime? SnapshotDate { get; set; }

            [DisplayName("手机号")]
            public String CellPhone { get; set; }

            [DisplayName("应付金额")]
            public double AmountDue { get; set; }

            [DisplayName("缴费金额")]
            public double Payment { get; set; }

            [DisplayName("消费金额")]
            public double Balance { get; set; }

            public GroupPerCellPhone(DateTime? SnapshotDate, string CellPhone, double AmountDue, double Payment, double Balance)
            {
                this.SnapshotDate = SnapshotDate;
                this.CellPhone = CellPhone;
                this.AmountDue = AmountDue;
                this.Payment = Payment;
                this.Balance = Balance;
            }
        }
        public long ID { get; set; }


        [DisplayName("日期")]
        [DisplayFormat(DataFormatString = "{0:MM/dd/yyyy}")]
        public DateTime? SnapshotDate { get; set; }

        [DisplayName("今日缴费金额")]
        public double? TodayPayment { get; set; }

        public Guid BillID { get; set; }

        [DisplayName("缴费金额")]
        public double Payment { get; set; }

        [DisplayName("消费金额")]
        public double Balance { get; set; }

        [DisplayName("缴费者类型")]
        public int? PayerRole { get; set; }

        [DisplayName("应付金额")]
        public double AmountDue { get; set; }

        public Guid CustomerID { get; set; }

        [DisplayName("更新时间")]
        [DisplayFormat(DataFormatString = "{0:MM/dd/yyyy}")]
        public DateTime ModifiedDate { get; set; }

        public Guid UserID { get; set; }

        [DisplayName("名(不包含姓氏)")]
        public String FirstName { get; set; }


        [DisplayName("姓氏")]
        public String LastName { get; set; }

        [DisplayName("手机号")]
        public String CellPhone { get; set; }

        [DisplayName("额外电话号码")]
        public String SecondPhone { get; set; }

        [DisplayName("电子邮箱地址")]
        public String Email { get; set; }

        [DisplayName("地址")]
        public String Address { get; set; }

        [DisplayName("身份证号")]
        public String IDNumber { get; set; }


    }
}
