﻿namespace CCSPrototypeCommon
{

    using Microsoft.Azure;
    using System.Configuration;


    public static class ConfigurationMgr
    {
        public static string GetSetting(string settingName)
        {
            // Get connection string from the service configuration file.
            var connString
                 = CloudConfigurationManager.GetSetting(settingName);
            if (string.IsNullOrWhiteSpace(connString))
            {
                // Fall back to app settings section in Web.config.
                return ConfigurationManager.AppSettings[settingName];
            }
            return connString;
        }
    }
}