﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Configuration;
using CCSAdmin;
using CCSPrototypeCommon;

namespace CcsAdminTests
{
    [TestClass]
    public class TestInit
    {
        private static readonly string clientId = ConfigurationMgr.GetSetting("ida:ClientId");
        private static readonly string appKey = ConfigurationMgr.GetSetting("ida:AppKey");
        private static readonly string aadInstance = ConfigurationMgr.GetSetting("ida:AADInstance");
        private static readonly string aadTenant = ConfigurationMgr.GetSetting("ida:Tenant");
        private static readonly string aadTenantId = ConfigurationMgr.GetSetting("ida:TenantId");

        private static readonly string graphRoot = ConfigurationMgr.GetSetting("ida:GraphUrl");

        [AssemblyInitialize]
        public static void Setup(TestContext context)
        {
            CcsAdmin.Instance.InitAdminCredentials(clientId, appKey, aadInstance, graphRoot, aadTenant, aadTenantId);

        }
    }
}
