﻿/***This should be run under cloudcomspacelogs database***/
/***CCS_Logs_V1***/
CREATE TABLE [dbo].[CCS_Logs_V1] (
    [LogsID]       UNIQUEIDENTIFIER DEFAULT (newsequentialid()) NOT NULL,
    [ClassName]     NVARCHAR (MAX)   NOT NULL,
	[Type]     TINYINT          NOT NULL,
    [Message]   NVARCHAR (MAX)		 NULL,
    [ModifiedDate] DATETIME         NOT NULL,
    CONSTRAINT [PK_dbo.CCS_Logs_V1] PRIMARY KEY CLUSTERED ([LogsID] ASC),
    
);


/***This should be run under cloudcomspacelogs database***/
/***CCS_Meta_V1***/
CREATE TABLE [dbo].[CCS_Meta_V1] (
    [MetaID]       UNIQUEIDENTIFIER DEFAULT (newsequentialid()) NOT NULL,
    [Name]       NVARCHAR (MAX)   NOT NULL,
    [Value]     NVARCHAR (MAX)   NOT NULL,
	CONSTRAINT [PK_dbo.CCS_Meta_V1] PRIMARY KEY CLUSTERED ([MetaID] ASC),
	
    
);
