﻿using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace HomeWeb.Models
{
    public class BillTemplateModel
    {
        public BillTemplateModel() 
        {
            BillHeaderList = new List<string>();
            BillTemplateColumnList = new List<string>();
        }

        public List<string> BillHeaderList { get; set; }

        public List<string> BillTemplateColumnList { get; set; }

        [Required]
        [MinLength(3)]
        [DisplayName("账单类型")]
        public string BillType { get; set; }
    }
}